#include "extern.h"
/* change to EntityDecl to local shape before writing it if it is 
   aliged arrays */

Node *change_EntityDecl(node) 
Node *node;
{ 
 T_Entry *entry;
 Node *sublist;
 entry=lookup_loc (node->EntityDecl.Name->com.str);
 if (IS_aligned(entry))
   {
     sublist = typ_shape_to_sublist_decl(entry->local_shape);
     node->EntityDecl.opt7 = make_opt7(sublist);
   }
return node;
}

/* this called at parse_EntityDecl to make all array local shape same as global
   shape later on Align statement will change for distributed array. */

Shape *make_local_shape(shape)
Shape *shape;
{
 Shape *local_shape = shape_malloc();
 int i;  
  local_shape->rank = shape->rank;
  local_shape->sizes0 = sizes_malloc ( local_shape->rank);
  local_shape->sizes1 = sizes_malloc ( local_shape->rank);
  local_shape->sizes2 = sizes_malloc ( local_shape->rank);
  local_shape->extent = sizes_malloc ( local_shape->rank);
  for(i=0; i<shape->rank; i++){
     local_shape->distr_dim[i]=-1;
     local_shape->sizes0[i] = shape->sizes0[i];
     local_shape->sizes1[i] = shape->sizes1[i];
     local_shape->extent[i] = shape->extent[i];
   }
  return local_shape;
}



find_local_shape(entry)
T_Entry *entry;
{
  Shape *local_shape = shape_malloc();
  Node *sub,*sub1, *temp, *temp1;
  char *name_index;
  int i,j, mapped_dim;
  

  local_shape->rank = entry->typ->shape->rank;
  local_shape->sizes0 = sizes_malloc ( local_shape->rank);
  local_shape->sizes1 = sizes_malloc ( local_shape->rank);
  local_shape->sizes2 = sizes_malloc ( local_shape->rank);
  local_shape->extent = sizes_malloc ( local_shape->rank);

  if ((entry->indexlist == NN) &&
      (entry->template_indexlist == NN))  /* case: align a with b */
    {  
       for(i=0; i<entry->typ->shape->rank; i++)
	{
          make_local_shape_dim(entry,local_shape, i, i);
       }
       
     }
    else
      {
        mapped_dim=-1;        
        i=0;
        for (LIST_LOOP ( sub, list_invert(entry->indexlist), temp)){

              if(!sub->Subscript.Colon)
                 {
                 name_index = sub->Subscript.Expr->com.str;
                  j=0;
                  for (LIST_LOOP ( sub1, list_invert(entry->template_indexlist), temp1)){
                      if ( misc_is_name_in_tree(name_index, sub1))
                             mapped_dim=j;        
                      j++;
		    }
                   make_local_shape_dim(entry,local_shape, i, mapped_dim);                 
		}
              else
                 {
                  local_shape->distr_dim[i]=-1;
                  local_shape->sizes0[i] = entry->typ->shape->sizes0[i];
                  local_shape->sizes1[i] = entry->typ->shape->sizes1[i];
                  local_shape->extent[i] = entry->typ->shape->extent[i];
                 }
                 i++;
}
}
              entry->local_shape = local_shape;

}              


make_local_shape_dim(entry,local_shape, dim, template_dim)
T_Entry *entry;
Shape *local_shape;
int dim, template_dim;
{
   Node *expr;
   T_Entry *proc_entry;
   char *num_proc_name;
   long value;


   /* this just  global pocessor names
      f90D programmer has to use in his program */
       
   zb_proc_name0=U_malloc(36);
   zb_proc_name1=U_malloc(36);
   zb_proc_name0="nproc0";
   zb_proc_name1="nproc1";;

   local_shape->distr_dim[dim]=template_dim;
   local_shape->sizes0[dim] = entry->typ->shape->sizes0[dim];
   if(template_dim==0)  num_proc_name=zb_proc_name0;
   else if (template_dim==1) num_proc_name = zb_proc_name1;
   else
        printf("ZB: template greater 2 is not implemented\n");
   
   if((proc_entry=lookup_loc(num_proc_name))==TN){
                 sprintf(serr, "%s have to be defined", num_proc_name);
                 fatal(serr);
	       }
   expr=make_DumExpr_PIN(entry->typ->shape->sizes1[dim], 
                     &Slash, ENTRY_VALUE(proc_entry));
   if(expr_is_constant_int(expr, &value))
	 {
            expr = make_IntegerConstant ( value );
    /* this save block0 and block1 to use later */ 
           if(template_dim==0)
               block0=expr;
            else 
               block1=expr;
            local_shape->sizes1[dim] = expr;
            local_shape->extent[dim] = expr;
          }
   else printf("ZB: Can not find local array shape\n");
 }

/*
distribute_loop(root)
Node *root;
{
  Node *var = root->AssignementStmt.Variable;
  char *name = var->com.str;
  T_Entry *entry = lookup_loc (name);
  int i,rank,type,kind;
  if(IS_aligned(entry)) {
    rank=root->com.typ->shape->rank;
    type=root->com.typ->etype->type;
    kind=root->com.typ->etype->kind;
    root->com.typ = typ_malloc();
    root->com.typ->shape = shape_malloc();
    root->com.typ->etype = etype_malloc_c(type,kind);
    root->com.typ->shape->sizes0 = sizes_malloc(rank);
    root->com.typ->shape->sizes1 = sizes_malloc(rank);
    root->com.typ->shape->sizes2 = sizes_malloc(rank);
    root->com.typ->shape->extent = sizes_malloc(rank);
    root->com.typ->shape->sizes2 = NN;
    root->com.typ->shape->extent = NN;

    for(i=0; i< rank; i++) {
     root->com.typ->shape->rank = rank;
     if(tree_eq(root->com.typ->shape->sizes0[i],entry->typ->shape->sizes0[i])
     && tree_eq(root->com.typ->shape->sizes1[i],entry->typ->shape->sizes1[i])){
        root->com.typ->shape->sizes0[i] = entry->local_shape->sizes0[i];     
        root->com.typ->shape->sizes1[i] = entry->local_shape->sizes1[i];     
        root->com.typ->shape->sizes2[i] = entry->local_shape->sizes2[i];     
        root->com.typ->shape->extent = entry->local_shape->extent;     
      }
       else make a call statement add it before root 
   }
  }
}
*/

distribute_loop(root)
Node *root;
{
  Node *var = root->AssignementStmt.Variable;
  char *name = var->com.str;
  T_Entry *entry = lookup_loc (name);
  int i,rank,type,kind;
  int distribute_dim;
  Node *block;

  if(IS_aligned(entry)) {
   for(i=0; i< root->com.typ->shape->rank; i++) {
    if(entry->local_shape->distr_dim[i]!= -1) {
     if(tree_eq(root->com.typ->shape->sizes0[i],entry->typ->shape->sizes0[i])
     && tree_eq(root->com.typ->shape->sizes1[i],entry->typ->shape->sizes1[i])){
        root->com.typ->shape->sizes0[i] =
                      tree_dup(root->com.typ->shape->sizes0[i]); 
        root->com.typ->shape->sizes1[i] =         
                      tree_dup(root->com.typ->shape->sizes1[i]);
/*        root->com.typ->shape->extent = 
                      tree_dup(root->com.typ->shape->extent );*/
        root->com.typ->shape->sizes0[i] = entry->local_shape->sizes0[i];     
        root->com.typ->shape->sizes1[i] = entry->local_shape->sizes1[i];     
        root->com.typ->shape->extent = entry->local_shape->extent;     
      }
      else
        { /* make a call statement add it before root */
         llb_num_index_set(root->com.typ->shape->rank);
         lub_num_index_set(root->com.typ->shape->rank);
         distribute_dim = entry->local_shape->distr_dim[i];
         if(distribute_dim == 0)
            block = block0;
         else 
            block = block1;

         call_adjust_local_bounds(root,
               root->com.typ->shape->sizes0[i],
               root->com.typ->shape->sizes1[i],i,
               distribute_dim, block);
               root->com.typ->shape->sizes0[i] = llb_index(i);
               root->com.typ->shape->sizes1[i] = lub_index(i);
       
       }
   }
  }
 }
}

